unit Unit1;

interface

uses

  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, IdBaseComponent, IdComponent,
  IdTCPConnection, IdTCPClient, IdHTTP, IdMultiPartFormData, wininet,
  IdIOHandler, IdIOHandlerSocket, IdIOHandlerStack, IdSSL, IdSSLOpenSSL;


type
  TForm1 = class(TForm)
    arquivo: TEdit;
    Label1: TLabel;
    retorno: TMemo;
    Label2: TLabel;
    OpenDialog1: TOpenDialog;
    Button1: TButton;
    url: TEdit;
    Label3: TLabel;
    btn_enviar: TButton;
    Bevel1: TBevel;
    login: TEdit;
    Label4: TLabel;
    senha: TEdit;
    Label5: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure btn_enviarClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin

 OpenDialog1.Execute;
 arquivo.Text := trim(OpenDialog1.Files.Text);

end;

procedure TForm1.btn_enviarClick(Sender: TObject);
var
  objFORM : TIdMultiPartFormDataStream;
  objSSL  : TIdSSLIOHandlerSocketOpenSSL;
  objHTTP : TIdHTTP;

  msg_erro : string;
begin

  msg_erro := '';

  if (trim(login.Text) = '') then
    msg_erro := msg_erro + '- Campo LOGIN  obrigatrio.'+#13;

  if (trim(senha.Text) = '') then
    msg_erro := msg_erro + '- Campo SENHA  obrigatrio.'+#13;

  if (trim(arquivo.Text) = '') then
    msg_erro := msg_erro + '- Campo arquivo  obrigatrio.'+#13;

  if ((msg_erro = '') and  (not FileExists(arquivo.Text))) then
    msg_erro := msg_erro + '- Arquivo no encontrado:'+ #13 + arquivo.Text + #13;

  if (msg_erro = '') then
    begin
        btn_enviar.Enabled := false;
        btn_enviar.Caption := 'Aguarde ....';

        {-- Objeto necessrio para envio quando for utilizar uma URL com HTTPS - INI --}
        objSSL := TIdSSLIOHandlerSocketOpenSSL.Create(Self);
        objSSL.Port := 0;
        objSSL.DefaultPort := 0;
        objSSL.SSLOptions.Method := sslvSSLv3;
        objSSL.SSLOptions.Mode := sslmUnassigned;
        objSSL.SSLOptions.VerifyMode := [];
        objSSL.SSLOptions.VerifyDepth := 0;
        {-- FIM --}

        objHTTP := TIdHTTP.Create(Self);
        objHTTP.IOHandler := objSSL;
        objHTTP.AllowCookies := true;
        objHTTP.ProxyParams.BasicAuthentication := false;
        objHTTP.ProxyParams.ProxyPort := 0;
        objHTTP.Request.ContentLength := -1;
        objHTTP.Request.Accept := 'text/html, */*';
        objHTTP.Request.BasicAuthentication := false;
        objHTTP.Request.UserAgent := 'Mozilla/3.0 (compatible; Indy Library)';
        objHTTP.HTTPOptions := [hoForceEncodeParams];

        objFORM  := TIdMultiPartFormDataStream.Create;
        objFORM.AddFormField('login', login.Text);
        objFORM.AddFormField('senha', senha.Text);
        objFORM.AddFile('f1', arquivo.Text , 'plain/text');

        try
          retorno.Text := objHTTP.Post(url.Text, objFORM);
        except
          on E:Exception do
            begin
              if Pos('404' , E.Message) > 0 then
                E.Message := 'URL no encontrada ('+ url.Text+')';

              showmessage('Erro: ' + E.Message);
            end;
        end;

        btn_enviar.Enabled := true;
        btn_enviar.Caption := 'Enviar para WEBSERVICES';

        FreeAndNil(objFORM);
        FreeAndNil(objSSL);
        FreeAndNil(objHTTP);
     end
   else
     begin
       showmessage(msg_erro);
     end;
end;

end.
